progname = exercise_06_45
CC = g++
CFLAGS = -Wall -Wextra -Werror -g3

$(progname): $(progname).o | .gitignore
	$(CC) $(CFLAGS) $^ -o $@

%.ii: %.cpp
	$(CC) -E $(CFLAGS) $< -o $@

%.s: %.ii
	$(CC) -S $(CFLAGS) $< -o $@

%.o: %.s
	$(CC) -c $(CFLAGS) $< -o $@

.gitignore:
	echo $(progname) > $@

clean:
	rm -f *.ii *.s *.o *.out $(progname) .gitignore

test: $(progname)
	./$(progname) < $@.in > $@.out 
	diff $@.out $@.expected && echo PASSED || echo FAILED

.PRECIOUS: $(progname).ii  $(progname).s
.SECONDARY: $(progname).ii  $(progname).s

